// monitor.h -- Defines the interface for monitor.h
//              From JamesM's kernel development tutorials.

#ifndef MONITOR_H
#define MONITOR_H

#include "common.h"

// Write a single character out to the screen.
void putc(char c);

// Clear the screen to all black.
void clear_screen();

// Output a null-terminated ASCII string to the monitor.
void puts(char *c);

// Output a hex value to the monitor.
void put_hex(u32int n);

// Output a decimal value to the monitor.
void put_dec(u32int n);

// Change the foreground and background colors
void set_colors(u8int fg, u8int bg);

// Move the cursor
void move_cursor(int x, int y);

#endif // MONITOR_H
